// ------------------------------------------------------------
// }bv
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float4x4 mWVP;
float4   vCol;
float4	 vLightDir;	// Cg̕

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture SrcTex;
sampler SrcSamp = sampler_state
{
    Texture = <SrcTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture CoverTex0;
sampler CoverSamp0 = sampler_state
{
    Texture = <CoverTex0>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex1;
sampler CoverSamp1 = sampler_state
{
    Texture = <CoverTex1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex2;
sampler CoverSamp2 = sampler_state
{
    Texture = <CoverTex2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex3;
sampler CoverSamp3 = sampler_state
{
    Texture = <CoverTex3>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex4;
sampler CoverSamp4 = sampler_state
{
    Texture = <CoverTex4>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex5;
sampler CoverSamp5 = sampler_state
{
    Texture = <CoverTex5>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex6;
sampler CoverSamp6 = sampler_state
{
    Texture = <CoverTex6>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
texture CoverTex7;
sampler CoverSamp7 = sampler_state
{
    Texture = <CoverTex7>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};
// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
};

// ------------------------------------------------------------
// ƖvZȂ_VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS (
      float4 Pos    : POSITION           // f̒_
     ,float4 Normal : NORMAL             // @xNg
     ,float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    float4 pos = mul( Pos, mWVP );
    
	// ʒuW
	Out.Pos = pos;
	
    Out.Tex0 = Tex0;
	
    return Out;
}
// ------------------------------------------------------------
// ƖvZȂsNZVF[_vO
// ------------------------------------------------------------
float4 vWeight[8];
float4 PS (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// Օ
	float Cover = dot(vWeight[0], tex2D( CoverSamp0, In.Tex0 ));
	      Cover+= dot(vWeight[1], tex2D( CoverSamp1, In.Tex0 ));
		  Cover+= dot(vWeight[2], tex2D( CoverSamp2, In.Tex0 ));
		  Cover+= dot(vWeight[3], tex2D( CoverSamp3, In.Tex0 ));
		  Cover+= dot(vWeight[4], tex2D( CoverSamp4, In.Tex0 ));
		  Cover+= dot(vWeight[5], tex2D( CoverSamp5, In.Tex0 ));
		  Cover+= dot(vWeight[6], tex2D( CoverSamp6, In.Tex0 ));
		  Cover+= dot(vWeight[7], tex2D( CoverSamp7, In.Tex0 ));
		  
	// F
	Out = tex2D( SrcSamp, In.Tex0 ) *(Cover+0.3f);

	return Out;
}
// ------------------------------------------------------------
// }bv쐬_VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS_Height (
      float4 Pos    : POSITION           // f̒_
    , float4 Normal : NORMAL             // @xNg
    , float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    float4 pos = mul( Pos, mWVP );
    
	// ʒuW
	Out.Pos = 2.0 * Tex0 - 1.0;
	Out.Pos.y *= -1;
	Out.Pos.z = 0.5;
	Out.Pos.w = 1;
	
	// F
	Out.Color = Pos.y;

    return Out;
}

// ------------------------------------------------------------
// }bv쐬sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Height (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// _O^[Qbg
	Out = In.Color;

	return Out;
}
// ------------------------------------------------------------
// Օ}bv쐬_VF[_vO
// ------------------------------------------------------------
float4 vOffset;
VS_OUTPUT VS_Cover (
      float4 Pos    : POSITION           // f̒_
    , float2 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // _W 
    Out.Pos = Pos;
    
	// F
	Out.Tex0 = Tex0;
	Out.Tex1 = Tex0+vOffset.xy;

    return Out;
}

// ------------------------------------------------------------
// Օ}bv쐬sNZVF[_vO
// ------------------------------------------------------------
float  fRayHeight;
float4 PS_Cover(VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	float4 center = tex2D( SrcSamp, In.Tex0 );
	float4 offset = tex2D( SrcSamp, In.Tex1 );

	Out = (center+fRayHeight < offset) ? 0 : 1;
	
	return Out;
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0 // }bv
    {
        VertexShader = compile vs_1_1 VS_Height();
        PixelShader  = compile ps_2_0 PS_Height();
    }
    pass P1 // Օ}bv
    {
        VertexShader = compile vs_1_1 VS_Cover();
        PixelShader  = compile ps_2_0 PS_Cover();
    }
    pass P2 // ƖvZȂ
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
